var bomHeaderSelectedIndex = undefined;
var BOM_HEADER_ID = undefined;
$(document).ready(function () {

    $('#txtProductID2').prop('disabled', true);
    allUOM();
    var bomHeaderTable = $('#bomHeaderTable').DataTable({
        responsive: true,
        "order": [],
        "columns": [
            { "data": "product_id" },
            { "data": "product_name" },
            { "data": "bom_name" },
            { "data": "quantity" },
            { "data": "wastage" },
            { "data": "uom" },
            { "data": "description" },
            // { "data": "status"},
            // { "data": "action" },
            { "data": "status", className: "status" },
            { "data": "action", className: "action" },


        ],
        // columnDefs: [
        //     { width: 100, targets: 1 },
        //     { width: 100, targets: 2 },
        //     { width: 100, targets: 3 }
        // ],
    });
    $('#bomDataTable').DataTable({
        responsive: true,
        "order": [],
        "columns": [
            { "data": "product_id" },
            { "data": "product_name" },
            { "data": "quantity" },
            { "data": "uom" },
            { "data": "tolerance" },
            { "data": "status" },
            { "data": "action" },

        ],
        columnDefs: [
            { width: 100, targets: 1 },
            { width: 100, targets: 2 },
            { width: 150, targets: 3 },
        ],
    });


    //Reset form
    $('#btnCancelAddBomHeader').on('click', function () {
        $('#BomHeaderForm').trigger("reset");
        $('#addbomHeaderModal').modal('toggle');
        $('#btnSaveAddBomHeader').show();
        $('#btnSaveAddBomHeader').text("Save");

    });


    $('#btnCancelAddBomData').on('click', function () {
        $('#BomDataForm').trigger("reset");
        $('#addbomDataModal').modal('toggle');
        $('#btnSaveAddBomData').show();
        $('#btnSaveAddBomData').text("Save");

    });


    /*$('#bomHeaderTable').DataTable({

    });

    $('#bomDataTable').DataTable({

    });*/


    //Ajax call for Auto complete product Name Field.
    $.ajax({
        type: 'GET',
        url: '/pp/bomHeader/searchPName',
        success: function (response) {
            console.log(response);
            if (response) {
                $("#txtProductName").setData(response);
            } else {
                showErrorMessage();
            }
        },
        error: function (data) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }
    });


    //Ajax call for Auto complete Material product Name Field.
    $.ajax({
        type: 'GET',
        url: '/pp/bomData/searchPDName',
        success: function (response) {
            console.log(response);
            if (response) {
                $("#txtProductName2").setData(response);
            } else {
                showErrorMessage();
            }
        },
        error: function (data) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }
    });



    /**
      * Save add bill of material
      * This function is used to save header order data.
      */
    $('#btnSaveAddBomHeader').click(function (event) {
        event.preventDefault();

        if ($('#txtProductID').val().trim() == '') {
            showWarningMessage('Please select product.');
            return;
        }

        if ($('#txtProductName').val().trim() == '') {
            showWarningMessage('Please select product.');
            return;
        }

        if ($('#txtBOMName').val().trim() == '') {
            showWarningMessage('Please enter BOM name.');
            return;
        }


        if ($('#txtQuantity').val().trim() == '') {
            showWarningMessage('Please enter quantity.');
            return;
        }

        var form = $('#BomHeaderForm').get(0);
        console.log(form);
        var data = new FormData(form);
        data.append('product_primary_id', $('#txtProductName').attr('data-id'));

        if ($('#btnSaveAddBomHeader').text() == "Save") {
            if (isSameBomName($('#txtBOMName').val(), $('#txtProductName').val())) {
                showWarningMessage("Already exist bom name.");
                return;
            }
            save(data);
            getBomHeader();
            $('#addbomHeaderModal').modal('toggle');

        } else if ($('#btnSaveAddBomHeader').text() == "Update") {
            updateBomHeader(data);

            $('#addbomHeaderModal').modal('toggle');


        }

    });







    /**
      * Save bill of material data
      * This function is used to save bill of material data.
      */

    $('#btnSaveAddBomData').click(function (event) {
        event.preventDefault();
        var form = $('#BomDataForm').get(0);
        var data = new FormData(form);
        data.append('uom', $('#cmbUOM').val());
        data.append('product_primary_id', $('#txtProductName2').optionID());
        data.append('pp_bom_header_id', BOM_HEADER_ID);
        var table = $('#bomHeaderTable').DataTable();

        var rowData = table.row(bomHeaderSelectedIndex).data();

        if ($('#btnSaveAddBomData').text() == "Save") {
            saveData();
            getBomData(rowData.pp_bom_header_id);
            $('#addbomDataModal').modal('toggle');

        } else if ($('#btnSaveAddBomData').text() == "Update") {
            updateBomData();
            getBomData(rowData.pp_bom_header_id);
            $('#addbomDataModal').modal('toggle');
        }



    });



    


    //load view bill of material data
    $('#bomDataTable tbody').on('click', '.btn-view', function (event) {
        event.preventDefault();
        var table = $('#bomDataTable').DataTable();
        console.log($(this).parents('tr').index());
        var rowData = table.row($(this).parents('tr').index() - 1).data();
        console.log(rowData);
        $('#addbomDataModal').modal('show');


        $.ajax({
            type: "GET",
            url: "/pp/bomData/bomData/" + rowData.pp_bom_plan_data_id,
            processData: false,
            contentType: false,
            cache: false,
            timeout: 800000,
            beforeSend: function () {

            },
            success: function (response) {
                console.log(response);
                $('#exampleModalLabel1').html("Bill of Material Data");
                $('#btnSaveAddBomData').hide();
                var pp_bom_header_id = response.data.result['bomData']['pp_bom_header_id'];
                var product_id = response.data.result['bomData']['product_id'];
                var product_name = response.data.result['bomData']['product_name'];
                var quantity = response.data.result['bomData']['quantity'];
                var uom = response.data.result['bomData']['uom'];
                var tolerance = response.data.result['bomData']['tolerance'];

                $('#txtBomHeaderId').val(pp_bom_header_id);
                $('#txtProductID2').val(product_id);
                $('#txtProductName2').val(product_name);
                $('#txtQuantity2').val(quantity);
                //$('#txtUom2').val(uom);
                setSelectedOption('cmbUOM', uom);
                $('#txtTolerance').val(tolerance);

                $('#addbomDataModal').modal('show');

            },
            error: function (error) {
                console.log(error);

            },
            complete: function () {

            }
        });



    });



    getBomHeader(1);




    $('#bomHeaderTable tbody').on('click', 'tr', function () {

        if ($(this).hasClass('selected')) {
            $(this).removeClass('selected');
        }
        else {
            bomHeaderTable.$('tr.selected').removeClass('selected');
            $(this).addClass('selected');

            var rowData = bomHeaderTable.row(this).data();
            BOM_HEADER_ID = rowData.pp_bom_header_id;
            bomHeaderSelectedIndex = $(this).index();
            getBomData(BOM_HEADER_ID);



        }
    });

});


function showModelAddBOMHeader() {
    $('#txtProductID').val('');
    $('#txtProductName').val('');
    $('#txtBOMName').val('');
    $('#txtQuantity').val('');
    $('#txtDescription').val('');
    $('#txtWastagepercentage').val(0);
    $('#btnSaveAddBomHeader').text('Save');
    $('#addbomHeaderModal').modal('toggle');
}

function showModelAddbomData() {
    if (bomHeaderSelectedIndex == undefined) {
        showWarningMessage("Please select BOM.");
        return;
    }
    $('#hidden_bom_data_id').val('');
    $('#txtProductID2').val('');
    $('#txtProductName2').val('');
    $('#txtProductName2').attr("data-id", '');
    $('#txtQuantity2').val('0');
    $('#txtTolerance').val('0');
    $('#btnSaveAddBomData').text('Save');
    $('#addbomDataModal').modal('toggle');
}
/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}


/**
* getPName
* Function for Auto Complete to fill other fields by enter the Name Field.
*/
function getProductName() {

    $.ajax({
        type: 'GET',
        url: '/pp/bomHeader/getPName/' + $('#txtProductName').optionID(),
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response) {
                $('#txtProductID').val(response.product_id);
                $('#txtuom').val(response.uom_id);

            } else {
                showErrorMessage();
            }
        },
        error: function (data) {
            showErrorMessage();
            console.log(data);
        },
        complete: function () {
        }
    });

}


/**
* getPDName
* Function for Auto Complete to fill other fields by enter the Name Field.
*/
function getMaterialName() {
    $.ajax({
        type: 'GET',
        url: '/pp/bomData/getPDName/' + $('#txtProductName2').optionID(),
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response) {
                $('#txtProductID2').val(response.product_id);
                $('#hid_product_primary_id').val(response.product_primary_id);
                //$('#txtUom2').val(response.uom_id);
                setSelectedOption('cmbUOM', response.uom_id);

            } else {
                showErrorMessage();
            }
        },
        error: function (data) {
            //showErrorMessage();
            console.log(data);
        },
        complete: function () {
        }
    });

}


/**
* save
* This function is used to save bill of material.
* @param dara This is the paramter to ajax data
*/
function save(data) {

    $.ajax({
        type: "POST",
        enctype: 'multipart/form-data',
        url: '/pp/bomHeader',
        data: data,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {



                showSuccessMessage("Bill of material details have been saved successfully...");

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {
            $('#BomHeaderForm').trigger("reset");
        }

    });
}

/**
* getBomHeader
* This function is used to get bill of material to the list view.
* This is the paramter to ajax data
*/
function getBomHeader() {

    var disable = { 0: "", 1: "checked" }
    $.ajax({
        type: "GET",
        url: "/pp/bomHeader/allbomHeader",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                var data = [];
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['pp_bom_header_id'];
                    var product_id = response.data.result[i]['product_code'];
                    var product_name = response.data.result[i]['product_name'];
                    var bom_name = response.data.result[i]['bom_name'];
                    var quantity = response.data.result[i]['quantity'];
                    var wastage_percentage = response.data.result[i]['wastage_percentage'];
                    var uom = response.data.result[i]['uom'];
                    var description = response.data.result[i]['description'];
                    var string_id = "'" + id + "'";
                    data.push({
                        "pp_bom_header_id": id,
                        "product_id": product_id,
                        "product_name": product_name,
                        "bom_name": bom_name,
                        "quantity": quantity,
                        "wastage": wastage_percentage,
                        "uom": uom,
                        "description": description,
                        "status": '<label class="switch ml-4"><input type="checkbox" id="' + response.data.result[i].pp_bom_header_id + '" onchange="disable(event, ' + "'BomHeader'" + ')" ' + disable[response.data.result[i].status] + '><span class="slider round"></span</lable>',
                        "action": '<button class="btn btn-warning mr-4 ml-2 btn-edit" onclick="getBomHeaderData(' + response.data.result[i].pp_bom_header_id + ')"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>      <button class="btn btn-success mr-4 btn-view"  onclick="getBomHeaderDataView(' + response.data.result[i].pp_bom_header_id + ')"><i class="fa fa-eye" aria-hidden="true"></i></button><button class="btn btn-danger" onclick="_delete(' + string_id + ')"><i class="fa fa-trash" aria-hidden="true"></i></button>',

                    });
                }


                var table = $('#bomHeaderTable').DataTable();
                table.clear();
                table.rows.add(data).draw();


            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}

/**
* delete
* This function is used to delete bill of material.
*/

function _delete(id) {
    $.ajax({
        type: 'DELETE',
        url: '/pp/bomHeader/' + id,
        data: {
            _token: $('input[name=_token]').val()
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage("Bill of material has been deleted successfully...")
                getBomHeader(1);
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}

/**
* updateBomHeader
* This function is used to update bill of material.
* @param data This is the paramter to ajax data
*/
function updateBomHeader(data) {
    console.log(data);

    $.ajax({
        type: "POST",
        enctype: 'multipart/form-data',
        url: '/pp/bomHeader/update/' + BOM_HEADER_ID,
        data: data,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Bill of material record has been updated successfully...");
                getBomHeader();

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {
            $('#BomHeaderForm').trigger("reset");
            $('#btnSaveAddBomHeader').text("Save");
        }

    });
}


/**
* disabled
* This function is used to update settings in bill of material header.
* @param url This is the paramter to ajax request url
* @param id This is the paramter to ajax data
*/
function _disabled(id, status) {

    var bool = 0;
    if (status) bool = 1;

    $.ajax({
        type: 'DELETE',
        url: '/pp/bomHeader/bomHeader/' + id,
        data: {
            _token: $('input[name=_token]').val(),
            "status": bool
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {

                if (status) showSuccessMessage("Data has been enabled successfully...");
                if (!status) showSuccessMessage("Data has been disabled successfully...");



            } else {
                var msg = response.data.message;
                var id = response.data.result;

                if (msg == "assigned") {
                    //assigned settings cannot be disabled
                    showWarningMessage("Settings has been assigned...!");

                } else if (msg == "error") {
                    showErrorMessage();
                }
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}



/**
* save
* This function is used to disable settings in bill of material.
* @param event This is the paramter to identifi desable/enable
*/
function disable(event) {
    var id = event.target.id;
    var status = event.target.checked;
    _disabled(id, status);
}



/**
* saveData
* This function is used to save bill of material data.
* @param dara This is the paramter to ajax data
*/
function saveData() {

    if($('#txtProductID2').val().trim() == ''){
        showWarningMessage('Please select product.');
        return;
    }

    if($('#txtProductName2').val().trim() == ''){
        showWarningMessage('Please select product.');
        return;
    }

    if($('#txtQuantity2').val().trim() == ''){
        showWarningMessage('Please enter quantity.');
        return;
    }


    if($('#txtTolerance').val().trim() == ''){
        showWarningMessage('Please enter tolerance.');
        return;
    }


    $.ajax({
        type: "POST",
        url: '/pp/bomData',
        data: {
            'pp_bom_header_id': BOM_HEADER_ID,
            'product_primary_id': $('#txtProductName2').optionID(),
            'product_id': $('#txtProductID2').val(),
            'product_name': $('#txtProductName2').val(),
            'quantity': $('#txtQuantity2').val(),
            'uom': $('#cmbUOM').val(),
            'tolerance': $('#txtTolerance').val(),
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Bill of material data details have been saved successfully...");


            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {
            $('#BomDataForm').trigger("reset");
        }

    });
}


/**
* getBomData
* This function is used to get bill of material data to the list view.
* This is the paramter to ajax data
*/
function getBomData(order_id) {

    $.ajax({
        type: "GET",
        url: "/pp/bomData/allbomData/" + order_id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                var data = [];
                var disableData = { 0: "", 1: "checked" }
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['pp_bom_plan_data_id'];
                    var product_id = response.data.result[i]['product_id'];
                    var material = response.data.result[i]['product_name'];
                    var quantity = response.data.result[i]['quantity'];
                    var uom = response.data.result[i]['uom_name'];
                    var tolerance = response.data.result[i]['tolerance'];
                    var string_id = "'" + id + "'";
                    data.push({
                        "product_id": product_id,
                        "product_name": material,
                        "quantity": quantity,
                        "uom": uom,
                        "tolerance": tolerance,
                        "status": '<label class="switch ml-4"><input type="checkbox" id="' + response.data.result[i].pp_bom_plan_data_id + '" onchange="disableData(event,' + "'BomData'" + ')" ' + disableData[response.data.result[i].status] + '><span class="slider round"></span</lable>',
                        "action": '<button class="btn btn-warning mr-4 ml-2 btn-edit" data-toggle="modal" onclick="edit(' + string_id + ')"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button><button class="btn btn-success mr-4 btn-view" data-toggle="modal" onclick="view(' + string_id + ')"><i class="fa fa-eye" aria-hidden="true"></i></button><button class="btn btn-danger" onclick="_deleted(' + string_id + ')"><i class="fa fa-trash" aria-hidden="true"></i></button>',
                    });
                }


                var table = $('#bomDataTable').DataTable();
                table.clear();
                table.rows.add(data).draw();


            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}

/**
* deleted
* This function is used to delete bill of material data.
*/
function _deleted(id) {
    var table = $('#bomHeaderTable').DataTable();
    var rowData = table.row(bomHeaderSelectedIndex).data();
    $.ajax({
        type: 'DELETE',
        url: '/pp/bomData/' + id,
        data: {
            _token: $('input[name=_token]').val()
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage("Bill of material data has been deleted successfully....")
                getBomData(rowData.pp_bom_header_id);
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}


/**
* updateBomData
* This function is used to update bill of material data.
* @param data This is the paramter to ajax data
*/
function updateBomData() {

    $.ajax({
        type: "POST",
        enctype: 'multipart/form-data',
        url: '/pp/bomData/update',
        data: {
            'bom_data_id': $('#hidden_bom_data_id').val(),
            'pp_bom_header_id': BOM_HEADER_ID,
            'product_primary_id': $('#txtProductName2').optionID(),
            'product_id': $('#txtProductID2').val(),
            'product_name': $('#txtProductName2').val(),
            'quantity': $('#txtQuantity2').val(),
            'uom': $('#cmbUOM').val(),
            'tolerance': $('#txtTolerance').val(),
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Bill of material data record has been updated successfully...");

            } else {
                showErrorMessage();
            }


        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {
            $('#BomDataForm').trigger("reset");
            $('#btnSaveAddBomData').text("Save");

        }

    });
}


/**
* delete
* This function is used to update settings in bill of material data.
* @param url This is the paramter to ajax request url
* @param id This is the paramter to ajax data
*/
function _disableData(id, status) {

    var bool = 0;
    if (status) bool = 1;

    $.ajax({
        type: 'DELETE',
        url: '/pp/bomData/bomData/' + id,
        data: {
            _token: $('input[name=_token]').val(),
            "status": bool
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {

                if (status) showSuccessMessage("Data has been enabled successfully...");
                if (!status) showSuccessMessage("Data has been disabled successfully...");



            } else {
                var msg = response.data.message;
                var id = response.data.result;

                if (msg == "assigned") {
                    //assigned settings cannot be disabled
                    showWarningMessage("Settings has been assigned...!");

                } else if (msg == "error") {
                    showErrorMessage();
                }
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}



/**
* save
* This function is used to disable settings in bill of material data.
* @param event This is the paramter to identifi desable/enable
*/
function disableData(event) {
    var id = event.target.id;
    var status = event.target.checked;
    _disableData(id, status);
}




function allUOM() {

    $.ajax({
        type: 'GET',
        url: '/pp/bomData/allUOM',
        async: false,
        success: function (response) {
            console.log(response.data.result);
            var uom = response.data.result;
            $('#cmbUOM').empty();
            for (var i = 0; i < uom.length; i++) {
                $('#cmbUOM').append('<option value="' + uom[i].id + '">' + uom[i].name + '</option>');
                $('#cmbUOM_BOM').append('<option value="' + uom[i].id + '">' + uom[i].name + '</option>');
            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
}



function setSelectedOption(id, valueToSelect) {
    let element = document.getElementById(id);
    element.value = valueToSelect;
}



function edit(id) {
    getSelectedBomData(id);
    $("#addProductOrderModal").modal('show');
}



function view(id) {
    getSelectedBomData(id);
    $("#addProductOrderModal").modal('show');
}

function getSelectedBomData(id) {


    $.ajax({
        type: 'GET',
        url: '/pp/bomData/getSelectedBomData/' + id,
        async: false,
        success: function (response) {
            console.log(response.data.result);
            var data = response.data.result;
            $('#hidden_bom_data_id').val(data.pp_bom_plan_data_id);
            $('#txtProductID2').val(data.product_id);
            $('#txtProductName2').val(data.product_name);
            $('#txtProductName2').attr("data-id", data.product_primary_id);
            $('#txtQuantity2').val(data.quantity);
            $('#txtTolerance').val(data.tolerance);
            setSelectedOption('cmbUOM', data.uom);
            $('#addbomDataModal').modal('toggle');
            $('#btnSaveAddBomData').text('Update');

        },
        error: function (data) {

        },
        complete: function () {

        }
    });
}



function isSameBomName(bom, product) {

    var bool = false;
    $.ajax({
        type: 'GET',
        url: '/pp/bomData/isSameBomName/' + bom + "/" + product,
        async: false,
        success: function (response) {
            console.log(response.data.result);
            bool = response.data.result;
        },
        error: function (data) {

        },
        complete: function () {

        }
    });

    return bool;
}




function getBomHeaderData(id) {


    $('#txtProductID').val('');
    $('#txtProductName').attr('data-id', '');
    $('#txtProductName').val('');
    $('#txtBOMName').val('');
    $('#txtQuantity').val('0');
    $('#txtDescription').val('');
    $('#txtWastagepercentage').val('0');

    $.ajax({
        type: "GET",
        url: "/pp/bomHeader/bomHeader/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            $('#exampleModalLabel').html("Edit Bill Of Material");
            $('#btnSaveAddBomHeader').text("Update");
            BOM_HEADER_ID = response.data.result['BomHeader']['pp_bom_header_id'];
            var product_id = response.data.result['BomHeader']['product_id'];
            var product_primary_id = response.data.result['BomHeader']['product_primary_id'];
            var product_name = response.data.result['BomHeader']['product_name'];
            var bom_name = response.data.result['BomHeader']['bom_name'];
            var quantity = response.data.result['BomHeader']['quantity'];
            var uom = response.data.result['BomHeader']['uom'];
            var description = response.data.result['BomHeader']['description'];
            var wastage_percentage = response.data.result['BomHeader']['wastage_percentage'];




            $('#txtProductID').val(product_id);
            $('#txtProductName').attr('data-id', product_primary_id);
            $('#txtProductName').val(product_name);
            $('#txtBOMName').val(bom_name);
            $('#txtQuantity').val(quantity);
            setSelectedOption('cmbUOM_BOM', uom);
            $('#txtDescription').val(description);
            $('#txtWastagepercentage').val(wastage_percentage);


            $('#btnSaveAddBomHeader').show();
            $('#addbomHeaderModal').modal('show');


        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });


}





function getBomHeaderDataView(id) {

    $('#txtProductID').val('');
    $('#txtProductName').attr('data-id', '');
    $('#txtProductName').val('');
    $('#txtBOMName').val('');
    $('#txtQuantity').val('0');
    $('#txtDescription').val('');
    $('#txtWastagepercentage').val('0');

    $.ajax({
        type: "GET",
        url: "/pp/bomHeader/bomHeader/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            $('#exampleModalLabel').html("Edit Bill Of Material");
            $('#btnSaveAddBomHeader').text("Update");
            BOM_HEADER_ID = response.data.result['BomHeader']['pp_bom_header_id'];
            var product_id = response.data.result['BomHeader']['product_id'];
            var product_primary_id = response.data.result['BomHeader']['product_primary_id'];
            var product_name = response.data.result['BomHeader']['product_name'];
            var bom_name = response.data.result['BomHeader']['bom_name'];
            var quantity = response.data.result['BomHeader']['quantity'];
            var uom = response.data.result['BomHeader']['uom'];
            var description = response.data.result['BomHeader']['description'];
            var wastage_percentage = response.data.result['BomHeader']['wastage_percentage'];




            $('#txtProductID').val(product_id);
            $('#txtProductName').attr('data-id', product_primary_id);
            $('#txtProductName').val(product_name);
            $('#txtBOMName').val(bom_name);
            $('#txtQuantity').val(quantity);
            setSelectedOption('cmbUOM_BOM', uom);
            $('#txtDescription').val(description);
            $('#txtWastagepercentage').val(wastage_percentage);


            $('#btnSaveAddBomHeader').hide();

            $('#addbomHeaderModal').modal('show');


        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });


}